/*
 * Copyright 2022 Peter <peter@quantr.hk>.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package hk.quantr.qemulogpanel;

import hk.quantr.dwarf.dwarf.CompileUnit;
import hk.quantr.dwarf.dwarf.Dwarf;
import hk.quantr.dwarf.dwarf.DwarfDebugLineHeader;
import hk.quantr.dwarf.dwarf.DwarfLib;
import hk.quantr.dwarf.dwarf.DwarfLine;
import hk.quantr.javalib.CommonLib;
import static hk.quantr.qemulogpanel.MyThread.p;
import java.awt.Component;
import java.awt.Image;
import java.awt.event.KeyEvent;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.math.BigInteger;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.atomic.AtomicLong;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.regex.Matcher;
import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JProgressBar;
import javax.swing.JTable;
import javax.swing.SwingUtilities;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.filechooser.FileNameExtensionFilter;
import me.tongfei.progressbar.ProgressBar;
import me.tongfei.progressbar.ProgressBarBuilder;
import org.apache.commons.io.IOUtils;
import org.apache.commons.lang3.StringUtils;
import org.json.JSONArray;

/**
 *
 * @author Peter <peter@quantr.hk>
 */
public class QemuLogPanel extends javax.swing.JPanel {

//	private static final Logger logger = Logger.getLogger(QemuLogPanel.class.getName());
	public static DecimalFormat decimalFormatter = new DecimalFormat("#,###");
	File file;
	SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
	CompareDialog compareDialog;
	ListErrorDialog listErrorDialog;
	private int viewWhich;

	/**
	 * Creates new form QemuLogPanel
	 */
	public QemuLogPanel() {
		initComponents();
		jTable1.setDefaultRenderer(Object.class, new MyTableRenderer());
		diffTable.setDefaultRenderer(Object.class, new DiffTableRenderer());
		openButton.setVisible(false);
		connectQemuButton.setVisible(false);
		jTable1.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
			@Override
			public void valueChanged(ListSelectionEvent e) {
				jTable1MouseClicked(null);
			}
		});
	}

	/**
	 * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form
	 * Editor.
	 */
	@SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        openButton = new javax.swing.JButton();
        connectQemuButton = new javax.swing.JButton();
        openDumpJsonButton = new javax.swing.JButton();
        autoWidthButton = new javax.swing.JButton();
        noOfRecordLabel = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        prevPageButton = new javax.swing.JButton();
        pageNoTextField = new javax.swing.JFormattedTextField();
        nextPageButton = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        rowNoTextField = new javax.swing.JFormattedTextField();
        jLabel2 = new javax.swing.JLabel();
        pageSizeComboBox = new javax.swing.JComboBox<>();
        jProgressBar1 = new javax.swing.JProgressBar();
        dimUnchangeCheckBox = new javax.swing.JCheckBox();
        cCodeCheckBox = new javax.swing.JCheckBox();
        label1 = new java.awt.Label();
        searchTextField = new javax.swing.JTextField();
        nextErrorButton = new javax.swing.JButton();
        nextChangeButton = new javax.swing.JButton();
        listErrorButton = new javax.swing.JButton();
        compareButton = new javax.swing.JButton();
        jSplitPane1 = new javax.swing.JSplitPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        diffTable = new javax.swing.JTable();
        jPanel3 = new javax.swing.JPanel();
        logoLabel = new javax.swing.JLabel();

        setLayout(new java.awt.BorderLayout());

        jPanel1.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        openButton.setText("Open Qemu Log");
        openButton.setFocusable(false);
        openButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        openButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        openButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                openButtonActionPerformed(evt);
            }
        });
        jPanel1.add(openButton);

        connectQemuButton.setText("Connect Qemu H2");
        connectQemuButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                connectQemuButtonActionPerformed(evt);
            }
        });
        jPanel1.add(connectQemuButton);

        openDumpJsonButton.setText("dump.json");
        openDumpJsonButton.setFocusable(false);
        openDumpJsonButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        openDumpJsonButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        openDumpJsonButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                openDumpJsonButtonActionPerformed(evt);
            }
        });
        jPanel1.add(openDumpJsonButton);

        autoWidthButton.setText("Width");
        autoWidthButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                autoWidthButtonActionPerformed(evt);
            }
        });
        jPanel1.add(autoWidthButton);

        noOfRecordLabel.setText("No of record,");
        noOfRecordLabel.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                noOfRecordLabelMouseClicked(evt);
            }
        });
        jPanel1.add(noOfRecordLabel);

        jLabel1.setText("Page No");
        jPanel1.add(jLabel1);

        prevPageButton.setText("<");
        prevPageButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                prevPageButtonActionPerformed(evt);
            }
        });
        jPanel1.add(prevPageButton);

        pageNoTextField.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        pageNoTextField.setText("0");
        pageNoTextField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                pageNoTextFieldKeyReleased(evt);
            }
        });
        jPanel1.add(pageNoTextField);

        nextPageButton.setText(">");
        nextPageButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nextPageButtonActionPerformed(evt);
            }
        });
        jPanel1.add(nextPageButton);

        jLabel3.setText("Row No");
        jPanel1.add(jLabel3);

        rowNoTextField.setText("0");
        rowNoTextField.setValue(0);
        rowNoTextField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                rowNoTextFieldKeyReleased(evt);
            }
        });
        jPanel1.add(rowNoTextField);

        jLabel2.setText("Page Size");
        jPanel1.add(jLabel2);

        pageSizeComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "1000", "2000", "5000", "10000", "20000", "50000", "100000" }));
        pageSizeComboBox.setSelectedItem("10000");
        pageSizeComboBox.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                pageSizeComboBoxItemStateChanged(evt);
            }
        });
        jPanel1.add(pageSizeComboBox);

        jProgressBar1.setPreferredSize(new java.awt.Dimension(200, 20));
        jProgressBar1.setStringPainted(true);
        jPanel1.add(jProgressBar1);
        jProgressBar1.setVisible(false);

        dimUnchangeCheckBox.setText("Dim Unchange");
        dimUnchangeCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                dimUnchangeCheckBoxActionPerformed(evt);
            }
        });
        jPanel1.add(dimUnchangeCheckBox);

        cCodeCheckBox.setText("C Code");
        cCodeCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cCodeCheckBoxActionPerformed(evt);
            }
        });
        jPanel1.add(cCodeCheckBox);

        label1.setText("Search");
        jPanel1.add(label1);

        searchTextField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                searchTextFieldKeyPressed(evt);
            }
            public void keyReleased(java.awt.event.KeyEvent evt) {
                searchTextFieldKeyReleased(evt);
            }
        });
        jPanel1.add(searchTextField);

        nextErrorButton.setText("Next Error");
        nextErrorButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nextErrorButtonActionPerformed(evt);
            }
        });
        jPanel1.add(nextErrorButton);

        nextChangeButton.setText("Next Change");
        nextChangeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nextChangeButtonActionPerformed(evt);
            }
        });
        jPanel1.add(nextChangeButton);

        listErrorButton.setText("List Error");
        listErrorButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                listErrorsActionPerformed(evt);
            }
        });
        jPanel1.add(listErrorButton);

        compareButton.setText("Compare");
        compareButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                compareButtonActionPerformed(evt);
            }
        });
        jPanel1.add(compareButton);

        add(jPanel1, java.awt.BorderLayout.PAGE_START);

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {

            }
        ));
        jTable1.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jTable1.getTableHeader().setReorderingAllowed(false);
        jTable1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jTable1MouseClicked(evt);
            }
        });
        jTable1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jTable1KeyPressed(evt);
            }
        });
        jScrollPane1.setViewportView(jTable1);

        jSplitPane1.setLeftComponent(jScrollPane1);

        jPanel2.setLayout(new java.awt.BorderLayout());

        diffTable.setModel(new DiffTableModel());
        diffTable.getTableHeader().setReorderingAllowed(false);
        jScrollPane2.setViewportView(diffTable);

        jPanel2.add(jScrollPane2, java.awt.BorderLayout.CENTER);

        logoLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        logoLabel.setIcon(CommonLib.resizeImageToIcon(new ImageIcon(getClass().getResource("/image/logo.png")), 210, 70, Image.SCALE_SMOOTH));
        logoLabel.setDoubleBuffered(true);
        logoLabel.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        logoLabel.setPreferredSize(new java.awt.Dimension(400, 70));
        jPanel3.add(logoLabel);

        jPanel2.add(jPanel3, java.awt.BorderLayout.PAGE_START);

        jSplitPane1.setRightComponent(jPanel2);

        add(jSplitPane1, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

    private void openButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_openButtonActionPerformed
		JFileChooser chooser = new JFileChooser(new File("."));
		FileNameExtensionFilter filter = new FileNameExtensionFilter("Qemu log", "log");
		chooser.setFileFilter(filter);
		int returnVal = chooser.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			file = chooser.getSelectedFile();
			openButton.setEnabled(false);
			new Thread() {
				@Override
				public void run() {
					try {
						convertQemuLogToH2(file, jProgressBar1, jTable1);
						openButton.setEnabled(true);
					} catch (SQLException ex) {
						Logger.getLogger(QemuLogPanel.class.getName()).log(Level.SEVERE, null, ex);
					}
				}
			}.start();
		}
    }//GEN-LAST:event_openButtonActionPerformed

    private void connectQemuButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_connectQemuButtonActionPerformed
		JFileChooser chooser = new JFileChooser(new File("."));
		FileNameExtensionFilter filter = new FileNameExtensionFilter("h2 database", "db");
		chooser.setFileFilter(filter);
		int returnVal = chooser.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			file = chooser.getSelectedFile();
			connect(file, jTable1, 0);
			noOfRecordLabel.setText(((MyTableModel) jTable1.getModel()).qemuCount + " records");
		}
    }//GEN-LAST:event_connectQemuButtonActionPerformed

    private void autoWidthButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_autoWidthButtonActionPerformed
		CommonLib.autoResizeColumnWithHeader(jTable1);
    }//GEN-LAST:event_autoWidthButtonActionPerformed

    private void dimUnchangeCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_dimUnchangeCheckBoxActionPerformed
		MyTableRenderer r = (MyTableRenderer) jTable1.getDefaultRenderer(Object.class);
		r.dimUnchange = dimUnchangeCheckBox.isSelected();
		MyTableModel model = (MyTableModel) jTable1.getModel();
		model.fireTableDataChanged();
    }//GEN-LAST:event_dimUnchangeCheckBoxActionPerformed

    private void openDumpJsonButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_openDumpJsonButtonActionPerformed
		JFileChooser chooser = new JFileChooser(new File("."));
		FileNameExtensionFilter filter = new FileNameExtensionFilter("json", "json");
		chooser.setFileFilter(filter);
		int returnVal = chooser.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			file = chooser.getSelectedFile();
			openDumpJson(file);
		}
    }//GEN-LAST:event_openDumpJsonButtonActionPerformed

    private void pageSizeComboBoxItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_pageSizeComboBoxItemStateChanged
		try {
			MyTableModel model = (MyTableModel) jTable1.getModel();
			model.pageSize = Integer.parseInt((String) pageSizeComboBox.getSelectedItem());
			model.loadQemuH2Database(model.database);
		} catch (Exception ex) {
			ex.printStackTrace();
		}
    }//GEN-LAST:event_pageSizeComboBoxItemStateChanged

    private void jTable1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable1MouseClicked
		if (jTable1.getSelectedRowCount() > 0) {
			MyTableModel model = (MyTableModel) jTable1.getModel();
			HashMap<String, CellData> data = model.data.get(jTable1.getSelectedRow());
			DiffTableModel diffModel = (DiffTableModel) diffTable.getModel();
			diffModel.data = data;

			Setting.getInstance().rowNo = jTable1.getSelectedRow();
			Setting.getInstance().save();

			// parse registers from current code
			String code = (String) data.get("CODE").quantrValue;
			code = code.replaceAll(".. ", "");
			ArrayList<String> registers = Register.getRegisters(code);
			if (jTable1.getSelectedRow() > 0) {
				code = (String) model.data.get(jTable1.getSelectedRow() - 1).get("CODE").quantrValue;
				code = code.replaceAll(".. ", "");
				ArrayList<String> registers2 = Register.getRegisters(code);
				registers.addAll(registers2);
			}
			diffModel.putOnTopRegisters = registers;
			// end parse registers from current code

			diffModel.fireTableStructureChanged();
		}
    }//GEN-LAST:event_jTable1MouseClicked

    private void cCodeCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cCodeCheckBoxActionPerformed
		try {
			MyTableModel model = (MyTableModel) jTable1.getModel();
			model.showCCode = cCodeCheckBox.isSelected();
			model.loadQemuH2Database(model.database);
		} catch (Exception ex) {
			ex.printStackTrace();
		}
    }//GEN-LAST:event_cCodeCheckBoxActionPerformed

    private void searchTextFieldKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_searchTextFieldKeyPressed

    }//GEN-LAST:event_searchTextFieldKeyPressed

    private void pageNoTextFieldKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_pageNoTextFieldKeyReleased
		if (evt.getKeyCode() == KeyEvent.VK_ENTER) {
			try {
				MyTableModel model = (MyTableModel) jTable1.getModel();
				int pageNo = Integer.parseInt(pageNoTextField.getText());
				Setting.getInstance().pageNo = pageNo;
				Setting.getInstance().save();
				model.pageNo = pageNo;
				model.loadQemuH2Database(model.database);
				CommonLib.autoResizeColumn(jTable1);
			} catch (Exception ex) {
				ex.printStackTrace();
			}
		}
    }//GEN-LAST:event_pageNoTextFieldKeyReleased

    private void searchTextFieldKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_searchTextFieldKeyReleased
		if (evt.getKeyCode() == KeyEvent.VK_ENTER) {
			int columnIndex = ((MyTableModel) jTable1.getModel()).getColumnIndex("CODE");
			if (columnIndex == -1) {
				return;
			}
			for (int x = jTable1.getSelectedRow() == -1 ? 0 : jTable1.getSelectedRow() + 1; x < jTable1.getRowCount(); x++) {
				CellData cCode = (CellData) jTable1.getValueAt(x, columnIndex);
				if (((String) cCode.qemuValue).contains(searchTextField.getText())) {
					jTable1.setRowSelectionInterval(x, x);
					CommonLib.scrollTableToVisible(jTable1, x, 0);
					return;
				}
			}
		}
    }//GEN-LAST:event_searchTextFieldKeyReleased

    private void rowNoTextFieldKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_rowNoTextFieldKeyReleased
		if (evt.getKeyCode() == KeyEvent.VK_ENTER) {
			setRowNo();
		}
    }//GEN-LAST:event_rowNoTextFieldKeyReleased

	public void setRowNo() {
		try {
			int pageSize = Integer.parseInt((String) pageSizeComboBox.getSelectedItem());
			int pageNo = Integer.parseInt(pageNoTextField.getText());
			int rowNo = Integer.parseInt(rowNoTextField.getText());
//		Setting.getInstance().rowNo = rowNo;
			int no = rowNo % pageSize;
			if (rowNo > pageNo * pageSize) {
//			pageNoTextField.setText(String.valueOf(rowNo / pageSize));
				pageNoTextFieldKeyReleased(new KeyEvent(this, 0, 0, 0, KeyEvent.VK_ENTER, ' '));
				jTable1.setRowSelectionInterval(no, no);
				CommonLib.scrollTableToVisible(jTable1, no + 20, 0);
			} else {
				jTable1.setRowSelectionInterval(no, no);
				CommonLib.scrollTableToVisible(jTable1, no + 20, 0);
			}
		} catch (Exception ex) {

		}
	}

    private void nextErrorButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nextErrorButtonActionPerformed
		for (int x = jTable1.getSelectedRow() + 1; x < jTable1.getRowCount(); x++) {
			Boolean b = (Boolean) jTable1.getValueAt(x, 0);
			if (!b) {
				jTable1.setRowSelectionInterval(x, x);
				CommonLib.scrollTableToVisible(jTable1, x + 20, 0);
				break;
			}
		}
    }//GEN-LAST:event_nextErrorButtonActionPerformed

    private void nextPageButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nextPageButtonActionPerformed
		int pageNo = Integer.parseInt(pageNoTextField.getText()) + 1;
		Setting.getInstance().pageNo = pageNo;
		Setting.getInstance().save();
		pageNoTextField.setText(String.valueOf(pageNo));
		pageNoTextFieldKeyReleased(new KeyEvent((Component) evt.getSource(), evt.getID(), 0, 0, KeyEvent.VK_ENTER, '\n'));
    }//GEN-LAST:event_nextPageButtonActionPerformed

    private void prevPageButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_prevPageButtonActionPerformed
		int pageNo = Integer.parseInt(pageNoTextField.getText()) - 1;
		Setting.getInstance().pageNo = pageNo;
		Setting.getInstance().save();
		pageNoTextField.setText(String.valueOf(pageNo));
		pageNoTextFieldKeyReleased(new KeyEvent((Component) evt.getSource(), evt.getID(), 0, 0, KeyEvent.VK_ENTER, '\n'));
    }//GEN-LAST:event_prevPageButtonActionPerformed

    private void nextChangeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nextChangeButtonActionPerformed
		int rowNo = jTable1.getSelectedRow();
		int colNo = jTable1.getSelectedColumn();
		if (rowNo != -1) {
			MyTableModel model = (MyTableModel) jTable1.getModel();
			long sequence = (Long) model.allQemudata.get(rowNo).get("SEQUENCE");
			String columnName = model.getColumnName(colNo);
//			String pc = (String) model.allQemudata.get(rowNo).get("PC");
			Object obj = model.getValueAt(rowNo, colNo);
			if (obj instanceof CellData) {
				try {
					CellData cellData = (CellData) obj;
					if (cellData.qemuValue instanceof BigInteger) {
						System.out.println(columnName + " = " + cellData.qemuValue);
						Connection qemuConn = DriverManager.getConnection("jdbc:h2:" + model.database.getAbsolutePath().replace(".mv.db", ""), "sa", "");
						Statement qemuStmt = qemuConn.createStatement();
						BigInteger b = (BigInteger) cellData.qemuValue;
						String sql = "select SEQUENCE from `qemu` where sequence>" + sequence + " and " + columnName + "!='0x" + StringUtils.leftPad(b.toString(16), 16, "0") + "' order by sequence limit 1";
						System.out.println(sql);
						ResultSet qemuRS = qemuStmt.executeQuery(sql);
						if (qemuRS.next()) {
							long temp = qemuRS.getLong("SEQUENCE");
							int pageSize = Integer.parseInt((String) pageSizeComboBox.getSelectedItem());
							pageNoTextField.setText(String.valueOf((temp / pageSize) + 1));
							pageNoTextFieldKeyReleased(new KeyEvent((Component) evt.getSource(), 0, 0, 0, KeyEvent.VK_ENTER, ' '));
							int newRowNo = (int) (temp % pageSize);
							jTable1.setRowSelectionInterval(newRowNo, newRowNo);
							CommonLib.scrollTableToVisible(jTable1, newRowNo, colNo);
						}
						qemuConn.close();
					}
				} catch (SQLException ex) {
					Logger.getLogger(QemuLogPanel.class.getName()).log(Level.SEVERE, null, ex);
				}
			}
		}
    }//GEN-LAST:event_nextChangeButtonActionPerformed

    private void jTable1KeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTable1KeyPressed
		if (!evt.isAltDown() && !evt.isControlDown() && !evt.isShiftDown() && (evt.getKeyCode() == java.awt.event.KeyEvent.VK_X || evt.getKeyCode() == java.awt.event.KeyEvent.VK_Z)) {
			int x = Math.max(0, jTable1.getSelectedRow() + (evt.getKeyCode() == java.awt.event.KeyEvent.VK_X ? 1 : -1));
			jTable1.setRowSelectionInterval(x, x);
			CommonLib.scrollTableToVisible(jTable1, jTable1.getSelectedRow(), 0);
			MyTableModel model = (MyTableModel) jTable1.getModel();
			HashMap<String, CellData> data = model.data.get(x);
			DiffTableModel diffModel = (DiffTableModel) diffTable.getModel();
			diffModel.data = data;
			diffModel.fireTableStructureChanged();
		} else if (evt.isControlDown() && evt.getKeyCode() == java.awt.event.KeyEvent.VK_X) {
			boolean currentMatch = (Boolean) jTable1.getValueAt(jTable1.getSelectedRow(), 0);
			int x = jTable1.getSelectedRow() + 1;
			if (!currentMatch) {
				for (; x < jTable1.getRowCount(); x++) {
					Boolean match = (Boolean) jTable1.getValueAt(x, 0);
					if (match) {
						break;
					}
				}
			}
			if (x == jTable1.getRowCount()) {
				return;
			}
			jTable1.setRowSelectionInterval(x, x);
			for (; x < jTable1.getRowCount(); x++) {
				Boolean match = (Boolean) jTable1.getValueAt(x, 0);
				if (!match) {
					jTable1.setRowSelectionInterval(x, x);
					CommonLib.scrollTableToVisible(jTable1, x + 20, 0);
					MyTableModel model = (MyTableModel) jTable1.getModel();
					HashMap<String, CellData> data = model.data.get(jTable1.getSelectedRow());
					DiffTableModel diffModel = (DiffTableModel) diffTable.getModel();
					diffModel.data = data;
					diffModel.fireTableStructureChanged();
					break;
				}
			}
		} else if (evt.isControlDown() && evt.getKeyCode() == java.awt.event.KeyEvent.VK_Z) {
			boolean currentMatch = (Boolean) jTable1.getValueAt(jTable1.getSelectedRow(), 0);
			int x = jTable1.getSelectedRow() - 1;
			if (!currentMatch) {
				for (; x >= 0; x--) {
					Boolean match = (Boolean) jTable1.getValueAt(x, 0);
					if (match) {
						break;
					}
				}
			}
			if (x < 0) {
				return;
			}
			jTable1.setRowSelectionInterval(x, x);
			for (; x >= 0; x--) {
				Boolean match = (Boolean) jTable1.getValueAt(x, 0);
				if (!match) {
					jTable1.setRowSelectionInterval(x, x);
					CommonLib.scrollTableToVisible(jTable1, x + 20, 0);
					MyTableModel model = (MyTableModel) jTable1.getModel();
					HashMap<String, CellData> data = model.data.get(jTable1.getSelectedRow());
					DiffTableModel diffModel = (DiffTableModel) diffTable.getModel();
					diffModel.data = data;
					diffModel.fireTableStructureChanged();
					break;
				}
			}
		} else if (evt.isAltDown() && evt.getKeyCode() == java.awt.event.KeyEvent.VK_A) {
			autoWidthButtonActionPerformed(null);
		}
    }//GEN-LAST:event_jTable1KeyPressed

    private void listErrorsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_listErrorsActionPerformed
		if (listErrorDialog == null) {
			MyTableModel model = (MyTableModel) jTable1.getModel();
			listErrorDialog = new ListErrorDialog(null, true, model.database);
		}
		listErrorDialog.setLocationRelativeTo(null);
		listErrorDialog.setVisible(true);
		if (listErrorDialog.process) {
			listErrorDialog.process = false;
			int pageSize = Integer.parseInt((String) pageSizeComboBox.getSelectedItem());
			int pageNo = (int) Math.ceil((double) listErrorDialog.sequence / pageSize) - 1;
			int rowNo = (int) (listErrorDialog.sequence - (pageNo * pageSize));
//			System.out.println("pageNo=" + pageNo);
//			System.out.println("aa=" + (double) d.sequence / Integer.parseInt((String) pageSizeComboBox.getSelectedItem()));
			if (pageNo != Integer.parseInt(pageNoTextField.getText())) {
				pageNoTextField.setText(String.valueOf(pageNo));
				KeyEvent e = new KeyEvent((Component) evt.getSource(), 0, 0, 0, KeyEvent.VK_ENTER, '\r', 0);
				pageNoTextFieldKeyReleased(e);
//			System.out.println("rowNo=" + rowNo);
			}
			jTable1.setRowSelectionInterval(rowNo, rowNo);
			jTable1MouseClicked(null);
			CommonLib.scrollTableToVisible(jTable1, 0, 0);
			CommonLib.scrollTableToVisible(jTable1, rowNo + 20, 0);
			autoWidthButtonActionPerformed(null);
		}
    }//GEN-LAST:event_listErrorsActionPerformed

    private void compareButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_compareButtonActionPerformed
		if (compareDialog == null) {
			MyTableModel model = (MyTableModel) jTable1.getModel();
			compareDialog = new CompareDialog(null, true, model.database);
		}
		compareDialog.setLocationRelativeTo(null);
		compareDialog.setVisible(true);
		if (compareDialog.process) {
			compareDialog.process = false;
			int pageSize = Integer.parseInt((String) pageSizeComboBox.getSelectedItem());
			int pageNo = (int) Math.ceil((double) compareDialog.sequence / pageSize) - 1;
			int rowNo = (int) (compareDialog.sequence - (pageNo * pageSize));
//			System.out.println("pageNo=" + pageNo);
//			System.out.println("aa=" + (double) d.sequence / Integer.parseInt((String) pageSizeComboBox.getSelectedItem()));
			if (pageNo != Integer.parseInt(pageNoTextField.getText())) {
				pageNoTextField.setText(String.valueOf(pageNo));
				KeyEvent e = new KeyEvent((Component) evt.getSource(), 0, 0, 0, KeyEvent.VK_ENTER, '\r', 0);
				pageNoTextFieldKeyReleased(e);
//			System.out.println("rowNo=" + rowNo);
			}
			jTable1.setRowSelectionInterval(rowNo, rowNo);
			jTable1MouseClicked(null);
			CommonLib.scrollTableToVisible(jTable1, 0, 0);
			CommonLib.scrollTableToVisible(jTable1, rowNo + 20, 0);
			autoWidthButtonActionPerformed(null);
		}
    }//GEN-LAST:event_compareButtonActionPerformed

    private void noOfRecordLabelMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_noOfRecordLabelMouseClicked
		if (viewWhich % 2 == 0) {
			noOfRecordLabel.setText(((MyTableModel) jTable1.getModel()).quantrCount + " records");
		} else {
			noOfRecordLabel.setText(((MyTableModel) jTable1.getModel()).qemuCount + " records");
		}
		viewWhich++;
    }//GEN-LAST:event_noOfRecordLabelMouseClicked

	public void openDumpJson(File file) {
		try {
			JSONArray json = new JSONArray(IOUtils.toString(new FileInputStream(file), "utf-8"));

			MyTableModel model = (MyTableModel) jTable1.getModel();
			model.json = json;
			model.loadQemuH2Database(model.database);
		} catch (Exception ex) {
			Logger.getLogger(QemuLogPanel.class.getName()).log(Level.SEVERE, null, ex);

		}
	}

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton autoWidthButton;
    private javax.swing.JCheckBox cCodeCheckBox;
    public javax.swing.JButton compareButton;
    public javax.swing.JButton connectQemuButton;
    private javax.swing.JTable diffTable;
    private javax.swing.JCheckBox dimUnchangeCheckBox;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    public javax.swing.JProgressBar jProgressBar1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    public javax.swing.JSplitPane jSplitPane1;
    public javax.swing.JTable jTable1;
    private java.awt.Label label1;
    private javax.swing.JButton listErrorButton;
    private javax.swing.JLabel logoLabel;
    private javax.swing.JButton nextChangeButton;
    private javax.swing.JButton nextErrorButton;
    private javax.swing.JButton nextPageButton;
    public javax.swing.JLabel noOfRecordLabel;
    public javax.swing.JButton openButton;
    private javax.swing.JButton openDumpJsonButton;
    public javax.swing.JFormattedTextField pageNoTextField;
    private javax.swing.JComboBox<String> pageSizeComboBox;
    private javax.swing.JButton prevPageButton;
    public javax.swing.JFormattedTextField rowNoTextField;
    private javax.swing.JTextField searchTextField;
    // End of variables declaration//GEN-END:variables

	public static ArrayList<String> getRegistersFromQemuLog(File qemuLog) {
		try {
			ArrayList<String> registers = new ArrayList();
			BufferedReader reader = Files.newBufferedReader(qemuLog.toPath()); //new BufferedReader(new FileReader(qemuLog), 100000);
			String line;
			do {
				line = reader.readLine();
				if (line.equals("") || line.startsWith("IN") || line.startsWith("Priv") || line.contains("----") || line.contains("V      =   0") || line.contains("Trace")) {
				} else if (line.startsWith("sifive_plic_irq_request")) {
				} else if (line.startsWith("Stopped execution of TB chain")) {
				} else if (line.startsWith("riscv_cpu_do_interrupt")) {
				} else if (line.startsWith("0x")) {
				} else if (line.startsWith("riscv_cpu_tlb_fill")) {
				} else {
					String words[] = line.trim().split(" +");
					for (int x = 0; x < words.length; x += 2) {
						words[x] = words[x].replaceAll("/", "_");
						registers.add(words[x]);
					}
				}
			} while (!line.startsWith(" x28"));
			reader.close();
			return registers;
		} catch (IOException ex) {
			Logger.getLogger(QemuLogPanel.class.getName()).log(Level.SEVERE, null, ex);
		}
		return null;
	}

	public static void convertQemuLogToH2(File qemuLog, JProgressBar progressBar, JTable table) throws SQLException {
		try {
			if (progressBar != null) {
				progressBar.setVisible(true);
			}

			// no of line
			long noOfLine = 0;
			System.out.println("Counting no of line: " + qemuLog.getCanonicalPath());
			if (CommonLib.getOS() == CommonLib.OSType.linux || CommonLib.getOS() == CommonLib.OSType.mac) {
				try {
					if (new File("/usr/local/bin/lc").exists()) {
						String command = "lc " + qemuLog.getAbsolutePath();
						System.out.println(command);
						noOfLine = Long.parseLong(CommonLib.runCommand(command).trim().split(" ")[0]);
					} else {
						String command = "wc -l " + qemuLog.getAbsolutePath();
						System.out.println(command);
						noOfLine = Long.parseLong(CommonLib.runCommand(command).trim().split(" ")[0]);
					}
				} catch (Exception ex) {
					Logger.getLogger(QemuLogPanel.class.getName()).log(Level.SEVERE, null, ex);
				}
			} else {
				noOfLine = Files.lines(qemuLog.toPath()).count();
			}
			// end no of line

			ConcurrentHashMap<Long, SourceData> allCode = new ConcurrentHashMap();
			ArrayList<Dwarf> dwarfVector = initKernelCodeCache(allCode, progressBar);

			// create DB
			Connection conn = DriverManager.getConnection("jdbc:h2:./database;CACHE_SIZE=13107200;PAGE_SIZE=10240;", "sa", "");
//			Connection conn = DriverManager.getConnection("jdbc:h2:mem:db1", "sa", "");
			conn.setAutoCommit(false);
			conn.createStatement().execute("drop table `qemu` if exists;");
			conn.createStatement().execute("create table `qemu`(id int auto_increment primary key not null, "
					+ "sequence bigint, "
					+ "date datetime, "
					+ "computer varchar(50), "
					+ "interrupt boolean, "
					+ "interrupt_cause bigint, "
					+ "interrupt_desc varchar(30));");
			ArrayList<String> registers = getRegistersFromQemuLog(qemuLog);
			for (String register : registers) {
				String sql = "ALTER TABLE `qemu` ADD `" + register + "` bigint NOT NULL;";
//							System.out.println(sql);
				conn.createStatement().execute(sql);
//				conn.createStatement().execute("create index if not exists `qemu_" + register + "` on qemu(`" + register + "`);");
			}

			conn.createStatement().execute("ALTER TABLE `qemu` ADD `lineNo` bigint");
			conn.createStatement().execute("ALTER TABLE `qemu` ADD `code` varchar(200);");
			conn.createStatement().execute("ALTER TABLE `qemu` ADD `mem` boolean;");
			conn.createStatement().execute("ALTER TABLE `qemu` ADD `memOperation` varchar(200);");
			conn.createStatement().execute("ALTER TABLE `qemu` ADD `memRead` boolean");
			conn.createStatement().execute("ALTER TABLE `qemu` ADD `memAddr` bigint");
			conn.createStatement().execute("ALTER TABLE `qemu` ADD `memValue` bigint");
			conn.createStatement().execute("ALTER TABLE `qemu` ADD `memSize` int");
			conn.createStatement().execute("ALTER TABLE `qemu` ADD `memHiJack` boolean;");
			conn.createStatement().execute("ALTER TABLE `qemu` ADD `memHiJackOperation` varchar(200);");
			conn.createStatement().execute("ALTER TABLE `qemu` ADD `memHiJackRead` boolean");
			conn.createStatement().execute("ALTER TABLE `qemu` ADD `memHiJackAddr` bigint");
			conn.createStatement().execute("ALTER TABLE `qemu` ADD `memHiJackValue` bigint");
			conn.createStatement().execute("ALTER TABLE `qemu` ADD `memHiJackSize` int");
			conn.createStatement().execute("ALTER TABLE `qemu` ADD `filename` varchar(100);");
			conn.createStatement().execute("ALTER TABLE `qemu` ADD `codeLineNo` int");
			conn.createStatement().execute("ALTER TABLE `qemu` ADD `cCode` varchar(100);");
			conn.createStatement().execute("ALTER TABLE `qemu` ADD `priv` int;");
			conn.createStatement().execute("ALTER TABLE `qemu` ADD `irqRequest` boolean");
			conn.createStatement().execute("ALTER TABLE `qemu` ADD `irqRequestNo` int");
			conn.createStatement().execute("ALTER TABLE `qemu` ADD `irqRequestLevel` int");
			conn.createStatement().execute("create index qemu_interrupt on `qemu`(interrupt);");
			conn.createStatement().execute("create index qemu_pc on `qemu`(pc);");
			conn.createStatement().execute("create index qemu_sequence on `qemu`(sequence);");
			conn.createStatement().execute("create index qemu_mem on `qemu`(mem);");
			conn.createStatement().execute("create index qemu_memHiJack on `qemu`(memHiJack);");
			conn.createStatement().execute("create index qemu_irqRequest on `qemu`(irqRequest);");
			conn.createStatement().execute("create index qemu_memAndIrqRequest on `qemu`(mem, irqRequest);");
			conn.createStatement().execute("create index qemu_memAddr on `qemu`(memAddr);");

			String sql = "INSERT INTO `qemu` VALUES (default, ?, CURRENT_TIMESTAMP(), 'quantr-ubuntu', ?, ?, ?";
			sql += ",?".repeat(registers.size());
			sql += ",?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
			PreparedStatement stmt = conn.prepareStatement(sql);
			// end create DB

			ProgressBarBuilder pbb = new ProgressBarBuilder().setTaskName("Reading  ").setUnit(" MB", 1048576);
			pbb.showSpeed();

//			BufferedReader reader = new BufferedReader(new FileReader(qemuLog), 1000000);
			BufferedReader reader = new BufferedReader(new InputStreamReader(ProgressBar.wrap(new FileInputStream(qemuLog), pbb)));

			final int NO_OF_THREAD = Runtime.getRuntime().availableProcessors() - 1;

			ProgressBar progressBars[] = new ProgressBar[NO_OF_THREAD];
			for (int x = 0; x < NO_OF_THREAD; x++) {
				progressBars[x] = new ProgressBar(String.format("Thread %02d", x), noOfLine - 1);
			}
			String line = null;
			long lineNo = 0;

			ExecutorService executor = Executors.newFixedThreadPool(NO_OF_THREAD);

			long sequence = 0;
			AtomicLong noOfPending = new AtomicLong();

			ArrayList<String> nextRecordLines = new ArrayList(); // scan mepc of next record
			ArrayList<String> tempLines = new ArrayList();
			int priv = -1; // because priv not appear every sector in qemu.log, so can't parse it inside H2Thread, has to be parse it outside to preseve previous value
			outer:
			do {
				ArrayList<String> lines = new ArrayList();

				if (!nextRecordLines.isEmpty()) {
					lines.addAll(nextRecordLines);
					nextRecordLines.clear();
				} else {
					if (!tempLines.isEmpty()) {  // add back lines that read to current lines e.g. memread / memwrite
						lines.addAll(tempLines);
						tempLines.clear();
					}

					do {
						line = reader.readLine();
						lineNo++;
						if (line == null) {
							break outer;
						}
						lines.add(line);
					} while (!line.startsWith(" x28"));
				}

				if (!tempLines.isEmpty()) {  // add back lines that read to current lines e.g. memread / memwrite
					lines.addAll(tempLines);
					tempLines.clear();
				}

				// see if hv interrupt
				tempLines.clear();
				for (int i = 0; i < 3; i++) {
					line = reader.readLine();
					lineNo++;
					if (line == null) {
						break outer;
					}
					tempLines.add(line);
					if (line.startsWith(" V")) { // reached next record, stop immediately, clear useless temp lines
						break;
					} else if (line.startsWith("riscv_cpu_do_interrupt") && line.contains("desc=m_timer")) { // have interrupt
						// check if the record needs to be ignored
						// if pc of current record == mepc of next record, then skip
						long pc = 0, mepc = 0;

						for (String temp : lines) { // scan pc
							if (temp.startsWith(" pc")) {
								pc = Long.parseLong(temp.replace(" pc       ", ""), 16);
								break;
							}
						}

						do {
							line = reader.readLine();
							lineNo++;
							if (line == null) {
								break outer;
							}
							nextRecordLines.add(line);
							if (line.startsWith(" mepc")) {
								mepc = Long.parseLong(line.replace(" mepc     ", ""), 16);
							}
						} while (!line.startsWith(" x28"));

						// compare
						if (pc == mepc) { // ignore current record
							lines.clear();
							lines.addAll(tempLines);
							lines.addAll(nextRecordLines); // put the next record to lines
							tempLines.clear();
							nextRecordLines.clear();
						}
						break;
					}
				}
				// end checking interrupt

				// check skip
				long skipAddress = 0;
				boolean skip = false;
				boolean skipCPU_recompile = true;
				long pc = -1;

				for (String temp : lines) {
					if (temp.startsWith("Stopped execution of TB chain")) {
						skip = true;
						Matcher m = p.matcher(temp);
						m.find();
						skipAddress = CommonLib.string2long("0x" + m.group(1));
					} else if (temp.startsWith(" pc")) {
						String words[] = temp.trim().split(" +");
						String value = words[1].startsWith("0x") ? words[1] : "0x" + words[1];
						pc = CommonLib.string2long(value);
						break;
					} else if (temp.startsWith("cpu_io_recompile")) {
						skipCPU_recompile = false;
					} else if (temp.startsWith("Priv")) {
						priv = Integer.parseInt(temp.split(";")[0].split(": ")[1]);
					}
				}
				// end check skip

				if (!(skip && pc == skipAddress) && skipCPU_recompile) {
					noOfPending.addAndGet(1);
					MyThread thread = new MyThread(dwarfVector, pc, sequence, lines, progressBars, lineNo, allCode, priv, stmt, noOfPending);
					executor.submit(thread);
					sequence++;

					if (sequence % 100000 == 0) {
						conn.commit();
					}

					while (noOfPending.get() > 100000) {
						try {
							Thread.sleep(2000);
						} catch (InterruptedException ex) {
							Logger.getLogger(QemuLogPanel.class.getName()).log(Level.SEVERE, null, ex);
						}
					}
				}
			} while (line != null);
			executor.shutdown();
			try {
				executor.awaitTermination(Long.MAX_VALUE, TimeUnit.NANOSECONDS);
			} catch (InterruptedException ex) {
				Logger.getLogger(QemuLogPanel.class.getName()).log(Level.SEVERE, null, ex);
			}
			stmt.executeBatch();
			conn.commit();

			ResultSet rs;

			rs = conn.prepareStatement("select count(*) from `qemu`;").executeQuery();
			rs.next();
			System.out.println("*******************");
			System.out.println("db rows = " + String.format("%,d", rs.getInt(1)));
			System.out.println("*******************");
		} catch (IOException ex) {
			Logger.getLogger(QemuLogPanel.class.getName()).log(Level.SEVERE, null, ex);
			System.exit(1);
		}
	}

	public static void connect(File database, JTable jTable1, int pageNo) {
		if (jTable1 == null) {
			return;
		}
		try {
			MyTableModel model = new MyTableModel();
			model.pageNo = pageNo;
			model.loadQemuH2Database(database);
			jTable1.setModel(model);
//		new Thread(() -> {
//			try {
//				Thread.sleep(2000);
//			} catch (InterruptedException ex) {
//				Logger.getLogger(QemuLogPanel.class.getName()).log(Level.SEVERE, null, ex);
//			}
//			CommonLib.autoResizeColumnWithHeader(jTable1);
//		}).start();
			SwingUtilities.invokeLater(new Runnable() {
				@Override
				public void run() {
					CommonLib.autoResizeColumnWithHeader(jTable1);
				}
			});
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	public static ArrayList<Dwarf> initKernelCodeCache(ConcurrentHashMap<Long, SourceData> allData, JProgressBar jProgressBar1) {
		File file = new File("../xv6-riscv/kernel/kernel".replaceFirst("^~", System.getProperty("user.home")));
		if (file.exists()) {
			final ArrayList<Dwarf> dwarfVector = DwarfLib.init(file, 0, false);
			if (dwarfVector != null) {
				for (Dwarf dwarf : dwarfVector) {
					for (CompileUnit cu : dwarf.compileUnits) {
						System.out.println(">" + cu.DW_AT_name);
						if (jProgressBar1 != null) {
							jProgressBar1.setString("processing " + cu.DW_AT_name);
						}
						DwarfDebugLineHeader header = cu.dwarfDebugLineHeader;
						for (DwarfLine line : header.lines) {
							try {
								File f = header.filenames.get((int) line.file_num).file;
//						String filename = file.getName();
								String code = Files.readAllLines(Paths.get(f.getAbsolutePath())).get((int) line.line_num - 1);
//						System.out.printf("%s, %d, 0x%08x\n", f.getAbsolutePath(), line.line_num, line.address);

								allData.put(line.address.longValue(), new SourceData(line.address.longValue(), line.line_num, f, code));
							} catch (Exception ex) {
//							ex.printStackTrace();
								System.out.println(ex.getMessage() + " > " + header.filenames.get((int) line.file_num).file.getAbsolutePath() + " : " + line.line_num);
							}
						}
					}
				}
			}
			return dwarfVector;
		}
		return null;
	}

	void openQuantrH2(File file) {
//		MyTableModel model = (MyTableModel) jTable1.getModel();
////		model.quantrH2 = file;
//		model.loadQemuH2Database(model.database);
	}

}
